#--*-coding:utf-8-*--

class BeastBindTrinity < DiceBot

#●前verからの変更・修正
# ・クリティカル値・ファンブル値算出の「@x」「#y」について、±の指定に対応。
#   あわせて、「ファンブルしても達成値が0にならない」モードを#yのオプションとして実装。

  alias ori_dice_command dice_command

  def initialize
    super
    @sendMode = 2;
    @sortType = 0;
    @d66Type = 2;
  end
  
  def gameName
    'ビーストバインド トリニティ'
  end
  
  def gameType
    "BeastBindTrinity"
  end
  
  def prefixs
     ['\d+BB', 'EMO']
  end
  
  def getHelpMessage
    info = <<INFO_MESSAGE_TEXT
・判定　(nBB+m%w@x#y$z)
　n個のD6を振り、出目の大きい2個から達成値を算出。修正mも可能。
　%w、@x、#y、$zはすべて省略可能。
＞%w：現在の人間性をwとして、クリティカル値を自動で計算する。
　省略した場合、クリティカル値は基本値の12として達成値を算出。
＞@x：クリティカル値がxであるとして判定を行う。加減式で入力可能。
　xの先頭が「+」か「-」なら、人間性から計算したC値にその値を加算する。
＞#y：ファンブル値がyであるとして判定を行う。加減式で入力可能。
　yの先頭が「+」か「-」なら、基本値2にその値を加算する。
　yの先頭に「A」を入れると、ファンブルしても達成値を通常通り算出。(例：#A2)
＞$z：ダイスの出目をその数値に固定して判定を行う。
　例）2BB$1→判定ダイス2個のうち、片方の出目を1で固定
　例）2BB$66→判定ダイス2個の出目を「6」「6」で固定し達成値を算出。

・邂逅表　EMO　　　・D66ダイスあり

INFO_MESSAGE_TEXT
  end
  
  
  def changeText(string)
    string = string.gsub(/(\d+)BB6/i) {"#{$1}R6"}
    string = string.gsub(/(\d+)BB/i)  {"#{$1}R6"}
    string = string.gsub(/\%([\-\d]+)/i)  {"[H:#{$1}]"}
    string = string.gsub(/\@([\+\-\d]+)/i)  {"[C#{$1}]"}
    string = string.gsub(/\#([A]?[\+\-\d]+)/i)  {"[F#{$1}]"}
    string = string.gsub(/\$([1-6]+)/i)  {"[S#{$1}]"}
    return string
  end

  
  def dice_command_xRn(string, nick_e)
    @nick = nick_e
    output_msg = bbt_check(string)
  end
  
  def check_2D6(total_n, dice_n, signOfInequality, diff, dice_cnt, dice_max, n1, n_max)  # ゲーム別成功度判定(2D6)
    return '' unless(signOfInequality == ">=")
    
    if(total_n >= diff)
      return " ＞ 成功";
    else
      return " ＞ 失敗";
    end
  end
  
  

  ####################           ビーストバインド トリニティ         ########################
  
  # 人間性からクリティカル値を算出
  def calc_critical(humanity)
    case humanity
      when (-1.0/0)..0 then return 9
      when 1..20 then return 10
      when 21..40 then return 11
      else return 12
    end
  end
  
  # 数式からクリティカル値を決定
  def get_critical(string, cri = 12)
    n = eval(string)
      debug("C指定符計算：#{n}")
    result = string.match(/^[\+\-][\+\-\d]+/) ? cri + n : n
      debug("クリティカル値 #{result}")
    return result
  end
  
  # 数式からファンブル値を決定
  def get_fumble(string)
    n = eval(string)
      debug("F値指定符計算：#{n}")
    result = string.match(/^[\+\-][\+\-\d]+/) ? 2 + n : n
      debug("ファンブル値 #{result}")
    return result
  end
  
  # 数式からダイス差し換え用の配列を取得
  def get_dicesubs(string, dice = 2)
    sub = []
    for i in string.split(//) do sub.push(i.to_i) if(sub.size < dice) end
      debug("出目差し換え #{sub}")
    return sub
  end

  def bbt_check(string)
    output = "1";

    debug("bbt string", string)
    unless(/(^|\s)S?((\d+)R6([\+\-\d]*)(\[H:([\-\d]+)\])?(\[C([\+\-\d+]+)\])?(\[F(A)?([\+\-\d]+)\])?(\[S([1-6]+)\])?(([>=]+)(\d+))?)(\s|$)/i =~ string)
      debug("not mutch")
      return output
    end
    
    string = $2;
    dice_c = $3.to_i;
    bonus = 0;
    signOfInequality = "";
    diff = 0;
    
    # クリティカル値・ファンブル値の初期設定
    hum = 99;
    cri = 12;
    fum =  2;
    afm = false;
    sub = [];
    
    bonusText = $4;
    bonus = parren_killer("(0" + bonusText + ")").to_i unless( bonusText.nil? )
    
    if($5)
      str_humanity = $6 if($6)
      debug("現在人間性 取得 #{str_humanity}")
    end
    
    if($7)
      str_critical = $8 if($8)
      debug("クリティカル値指定 取得 #{str_critical}")
    end
    
    if($9)
      str_afm = $10 if($10)
      debug("ファンブル耐性指定 取得 #{str_afm}")
      str_fumble = $11 if($11)
      debug("ファンブル値指定 取得 #{str_fumble}")
    end
    
    if($12)
      str_sub = $13 if($13)
      debug("ダイス出目差し換え 取得 #{str_sub}")
    end
    
    signOfInequality = $15 if($15);
    diff = $16.to_i if($16);
    
    
    # 指定された人間性からクリティカル値を計算
    if(str_humanity)
      hum = str_humanity.to_i
      cri = calc_critical(hum)
    end
    
    # クリティカル値/ファンブル値/ダイス差し換えの指定
    cri = get_critical(str_critical, cri) if(str_critical)
    fum = get_fumble(str_fumble) if(str_fumble)
    sub = get_dicesubs(str_sub, dice_c) if(str_sub)
    
    # ファンブル耐性があるかの判定
    if(str_afm)
      afm = true
      debug("ファンブル耐性モード")
    end
    
    dice_now = 0;
    dice_str = "";
    n_max = 0;
    total_n = 0;
    
    cri_flg   = false;
    cri_bonus = 0;
    fum_flg   = false;
    
    dice_tc = dice_c - sub.size
    
    if(dice_tc > 0)
      _, dice_str, = roll(dice_tc, 6, (sortType & 1))
      dice_num = (dice_str.split(/,/) + sub).collect{|n|n.to_i}
    elsif(sub.size == 0)
      return "Error:振るダイスの数が0個です"
    else
      dice_num = sub
    end
    
    dice_num.sort!													# 並べ替え
    dice_str = dice_num.join(",");									# dice_strの取得
    dice_now = dice_num[dice_c - 2] + dice_num[dice_c - 1];			# 判定の出目を確定
    
    if(dice_now >= cri)												# クリティカル成立の判定（ダイス目≦クリティカル値　で発生）
      cri_flg = true
      cri_bonus = 20;
    end
    
    total_n = [dice_now + bonus + cri_bonus, 0].max;				# 達成値の最小値は0
    
    if(fum >= dice_now)												# ファンブル成立の判定（ダイス目≧ファンブル値　で発生）
      fum_flg = true												# ファンブルすると基本達成値０
      total_n = 0 unless afm										#《この世ならざるもの》《しまった、こんな時に！》用の#Ayフラグ指定時は例外
    end
    
    dice_str = "[#{dice_str}]";
    
    # 表示文章の作成
    output = "#{dice_now}#{dice_str}"
    if(fum_flg == true && afm == false)
      output += "【ファンブル】"
    else
      output += "【ファンブル】" if(fum_flg)
      if(bonus > 0)
        output += "+#{bonus}"
      elsif(bonus < 0)
        output += "#{bonus}"
      end
      output += "+#{cri_bonus}【クリティカル】" if(cri_flg)
    end

    showstring = "#{dice_c}R6"							# 結果出力文におけるダイスロール式の作成
    if(bonus > 0)										# （結果出力の時に必ずC値・F値を表示するようにする）
      showstring += "+#{bonus}"
    elsif(bonus < 0)
      showstring += "#{bonus}"
    end
    showstring += "[C#{cri},F#{fum}]"
    if(signOfInequality != "")
      showstring += "#{signOfInequality}#{diff}"
    end
    
    if(sendMode > 0)												# 出力文の完成
      if(/[^\d\[\]]+/ =~ output)
        output = "#{@nick_e}: (#{showstring}) ＞ #{output} ＞ #{total_n}";
      else
        output = "#{@nick_e}: (#{showstring}) ＞ #{total_n}";
      end
    else
      output = "#{@nick_e}: (#{showstring}) ＞ #{total_n}";
    end
    
    if(signOfInequality != "")  # 成功度判定処理
      output += check_suc(total_n, dice_now, signOfInequality, diff, 2, 6, 0, 0);
    end
    
    return output
  end
  
  
  
  
  ####################           ビーストバインド トリニティ          ########################
  def rollDiceCommand(command)
    output = '1';
    type = "";
    total_n = 0

    case command
    
    # 邂逅表(d66)
    when /EMO/i
      type = '邂逅表';
      output, total_n = bbt_emotion_table
    end
    
    if(type == '邂逅表')
      if(output != '1')
        output = "#{type}(#{total_n}) ＞ #{output}";
      end
    end
    
    return output;
  end
  

  #**邂逅表(d66)
  def bbt_emotion_table
    table = [
      '家族',      '家族',      '信頼',      '信頼',      '忘却',      '忘却',
      '慈愛',      '慈愛',      '憧憬',      '憧憬',      '感銘',      '感銘',
      '同志',      '同志',      '幼子',      '幼子',      '興味',      '興味',
      'ビジネス',  'ビジネス',  '師事',      '師事',      '好敵手',    '好敵手',
      '友情',      '友情',      '忠誠',      '忠誠',      '恐怖',      '恐怖',
      '執着',      '執着',      '軽蔑',      '軽蔑',      '憎悪',      '憎悪',
    ]
    
    return get_table_by_d66(table)
  end
  
end
